---
title: WebGL2RenderingContext.texSubImage3D()
slug: Web/API/WebGL2RenderingContext/texSubImage3D
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.texSubImage3D()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API </a>specifies a sub-rectangle of the current texture.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void gl.texSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, ArrayBufferView? srcData, optional srcOffset);

void <var>gl</var>.texSubImage3D(<var>target</var>, <var>level</var>, <var>xoffset</var>, <var>yoffset</var>, <var>zoffset</var>, width, height, depth, <var>format</var>, <var>type</var>, ImageBitmap? <var>pixels</var>);

void <var>gl</var>.texSubImage3D(<var>target</var>, <var>level</var>, <var>xoffset</var>, <var>yoffset</var>, <var>zoffset</var>, width, height, depth, <var>format</var>, <var>type</var>, ImageData? <var>pixels</var>);

void <var>gl</var>.texSubImage3D(<var>target</var>, <var>level</var>, <var>xoffset</var>, <var>yoffset</var>, <var>zoffset</var>, width, height, depth, <var>format</var>, <var>type</var>, HTMLImageElement? <var>pixels</var>);

void <var>gl</var>.texSubImage3D(<var>target</var>, <var>level</var>, <var>xoffset</var>, <var>yoffset</var>, <var>zoffset</var>, width, height, depth, <var>format</var>, <var>type</var>, HTMLCanvasElement? <var>pixels</var>);

void <var>gl</var>.texSubImage3D(<var>target</var>, <var>level</var>, <var>xoffset</var>, <var>yoffset</var>, <var>zoffset</var>, width, height, depth, <var>format</var>, <var>type</var>, HTMLVideoElement? <var>pixels</var>);

void <var>gl</var>.texSubImage3D(<var>target</var>, <var>level</var>, <var>xoffset</var>, <var>yoffset</var>, <var>zoffset</var>, width, height, depth, <var>format</var>, <var>type</var>, GLintptr <var>offset</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) of the active texture. Possible values:
 <ul>
  <li><code>gl.TEXTURE_3D</code>: A three-dimensional texture.</li>
  <li><code>gl.TEXTURE_2D_ARRAY</code>: A two-dimensional array texture.</li>
 </ul>
 </dd>
 <dt><code>level</code></dt>
 <dd>A {{domxref("GLint")}} specifying the level of detail. Level 0 is the base image level and level <em>n</em> is the <em>n</em>th mipmap reduction level.</dd>
 <dt><code>xoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the x offset within the texture image.</dd>
 <dt><code>yoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the y offset within the texture image.</dd>
 <dt><code>zoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the z offset within the texture image.</dd>
 <dt><code>width</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the texture.</dd>
 <dt><code>height</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the texture.</dd>
 <dt><code>depth</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the depth of the texture.</dd>
 <dt><code>format</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the format of the texel data. Possible values:
 <ul>
  <li><code>gl.ALPHA</code>: Discards the red, green and blue components and reads the alpha component.</li>
  <li><code>gl.RGB</code>: Discards the alpha components and reads the red, green and blue components.</li>
  <li><code>gl.RGBA</code>: Red, green, blue and alpha components are read from the color buffer.</li>
  <li><code>gl.LUMINANCE</code>: Each color component is a luminance component, alpha is 1.0.</li>
  <li><code>gl.LUMINANCE_ALPHA</code>: Each component is a luminance/alpha component.</li>
  <li><code>gl.R8</code></li>
  <li><code>gl.R16F</code></li>
  <li><code>gl.</code>R32F</li>
  <li><code>gl.R8UI</code></li>
  <li><code>gl.RG8</code></li>
  <li><code>gl.RG16F</code></li>
  <li><code>gl.RG32F</code></li>
  <li><code>gl.RGUI</code></li>
  <li><code>gl.RGB8</code></li>
  <li><code>gl.SRGB8</code></li>
  <li><code>gl.RGB565</code></li>
  <li><code>gl.R11F_G11F_B10F</code></li>
  <li><code>gl.RGB9_E5</code></li>
  <li><code>gl.RGB16F</code></li>
  <li><code>gl.RGB32F</code></li>
  <li><code>gl.RGB8UI</code></li>
  <li><code>gl.RGBA8</code></li>
  <li><code>gl.SRGB_APLHA8</code></li>
  <li><code>gl.RGB5_A1</code></li>
  <li><code>gl.RGBA4444</code></li>
  <li><code>gl.RGBA16F</code></li>
  <li><code>gl.RGBA32F</code></li>
  <li><code>gl.RGBA8UI</code></li>
 </ul>
 </dd>
 <dt><code>type</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the data type of the texel data. Possible values:
 <ul>
  <li><code>gl.UNSIGNED_BYTE</code>: 8 bits per channel for <code>gl.RGBA</code></li>
  <li><code>gl.UNSIGNED_SHORT_5_6_5</code>: 5 red bits, 6 green bits, 5 blue bits.</li>
  <li><code>gl.UNSIGNED_SHORT_4_4_4_4</code>: 4 red bits, 4 green bits, 4 blue bits, 4 alpha bits.</li>
  <li><code>gl.UNSIGNED_SHORT_5_5_5_1</code>: 5 red bits, 5 green bits, 5 blue bits, 1 alpha bit.</li>
  <li><code>gl.BYTE</code></li>
  <li><code>gl.UNSIGNED_SHORT</code></li>
  <li><code>gl.SHORT</code></li>
  <li><code>gl.UNSIGNED_INT</code></li>
  <li><code>gl.INT</code></li>
  <li><code>gl.HALF_FLOAT</code></li>
  <li><code>gl.FLOAT</code></li>
  <li><code>gl.UNSIGNED_INT_2_10_10_10_REV</code></li>
  <li><code>gl.UNSIGNED_INT_10F_11F_11F_REV</code></li>
  <li><code>gl.UNSIGNED_INT_5_9_9_9_REV</code></li>
  <li><code>gl.UNSIGNED_INT_24_8</code></li>
  <li><code>gl.FLOAT_32_UNSIGNED_INT_24_8_REV</code> (pixels must be {{jsxref("null")}})</li>
 </ul>
 </dd>
 <dt><code>pixels</code></dt>
 <dd>One of the following objects can be used as a pixel source for the texture:
 <ul>
  <li>{{domxref("ArrayBufferView")}},
   <ul>
    <li>A {{jsxref("Uint8Array")}} must be used if <code>type</code> is <code>gl.UNSIGNED_BYTE</code>.</li>
    <li>A {{jsxref("Uint16Array")}} must be used if <code>type</code> is either <code>gl.UNSIGNED_SHORT_5_6_5</code>, <code>gl.UNSIGNED_SHORT_4_4_4_4</code>, <code>gl.UNSIGNED_SHORT_5_5_5_1</code>, or <code>ext.HALF_FLOAT_OES</code>.</li>
    <li>A {{jsxref("Float32Array")}} must be used if <code>type</code> is <code>gl.FLOAT</code>.</li>
   </ul>
  </li>
  <li>{{domxref("ImageBitmap")}},</li>
  <li>{{domxref("ImageData")}},</li>
  <li>{{domxref("HTMLImageElement")}},</li>
  <li>{{domxref("HTMLCanvasElement")}},</li>
  <li>{{domxref("HTMLVideoElement")}}.</li>
 </ul>
 </dd>
 <dt>offset</dt>
 <dd>A {{domxref("GLintptr")}} byte offset into the {{domxref("WebGLBuffer")}}'s data store. Used to upload data to the currently bound {{domxref("WebGLTexture")}} from the <code>WebGLBuffer</code> bound to the <code>PIXEL_UNPACK_BUFFER</code> target.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.texSubImage3D(gl.TEXTURE_3D, 0, 0, 0, 0, image.width, image.height, 1, gl.RGBA, gl.UNSIGNED_BYTE, image);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.6", "texSubImage3D")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glTexSubImage3D.xhtml", "glTexSubImage2D")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3.0 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.texSubImage3D")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.createTexture()")}}</li>
 <li>{{domxref("WebGLRenderingContext.bindTexture()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.copyTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getTexParameter()")}}</li>
</ul>
